//+------------------------------------------------------------------+
//|                                                      MTF_I.mq4 |
//   MTF_I
//|                                      Copyright  2006, Keris2112 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Keris2112"
#property link      "http://www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Black
#property indicator_width1 2
#property indicator_color2 Black
#property indicator_width2 2
#property indicator_color3 Magenta
#property indicator_width3 2
#property indicator_color4 Yellow
#property indicator_width4 2
#property indicator_color5 Aqua
#property indicator_width5 2
/*
#property indicator_buffers 1
#property indicator_color1 LightSeaGreen
#property indicator_level1 0
#property indicator_level2 100
#property indicator_level3 -100
#property indicator_level4 300
#property indicator_level5 -300
#property indicator_maximum 400
#property indicator_minimum -400
*/

//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
---------------------------------------
PRICE_CLOSE    0 Close price. 
PRICE_OPEN     1 Open price. 
PRICE_HIGH     2 High price. 
PRICE_LOW      3 Low price. 
PRICE_MEDIAN   4 Median price, (high+low)/2. 
PRICE_TYPICAL  5 Typical price, (high+low+close)/3. 
PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4. 
You must use the numeric value of the Applied Price that you want to use
when you set the 'applied_price' value with the indicator inputs.
**************************************************************************/
extern int TimeFrame=0;
/*
extern int CCIperiod=14;
extern int applied_price=5;


double ExtMapBuffer1[];
*/

//---- input parameters
extern double       A_period=8;
// int       B_period=8;
// int       neutral = 0;
extern int       num_bars=1000;
extern bool UseAlert = false;
extern bool UseEmail = false;

// parameters
/*
int i=0;
bool initDone=true;
int bar=0;
int prevbars=0;
int startpar=0;
int cs=0;
int prevcs=0;
string commodt="nonono";
int frame=0;
int bars=0;

int count = 0, thisbar = 0;
double now, prev;
bool flag;
*/

//---- buffers
double FastWoodieCCI[];
double SlowWoodieCCI[];
double HistoWoodieCCI[];
double HistoRed[];
double HistoBlue[];
datetime dt;
datetime TimeArray[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

//---- indicator line
  // SetIndexBuffer(0,ExtMapBuffer1);
  //  SetIndexStyle(0,DRAW_LINE);
   
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(0,FastWoodieCCI);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(1,SlowWoodieCCI);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(2,HistoWoodieCCI);
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(3,HistoRed);
   SetIndexStyle(4,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(4,HistoBlue);

//---- name for DataWindow and indicator subwindow label
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }
   
   //***Check for handling ERR_HISTORY_WILL_UPDATED ***
   // Plot defined time frame on to current time frame
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   IndicatorShortName("MTF I("+A_period+") ("+TimeFrameStr+")");
 //  IndicatorShortName("Retracement Finder 1 ("+A_period+")");

   //***Check for handling ERR_HISTORY_WILL_UPDATED ***
   // Plot defined time frame on to current time frame
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),0); 
   if(GetLastError()!=4066) Print("Historic data on Current TF is up to date (",iBars(Symbol(),0)," bars, first on ",TimeToStr(iTime(Symbol(),0,iBars(Symbol(),0)-1)),")");
   else {
       Print("Updating historic data on Current TF");
   }

  //}
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| MTF CCI                                                          |
//+------------------------------------------------------------------+
int start()
  {
   int    i,limit,y=0,counted_bars=IndicatorCounted();
 
 /*
   // Plot defined time frame on to current time frame
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
*/
 
   limit=Bars-counted_bars;
   
   //***Check for handling ERR_HISTORY_WILL_UPDATED ***
   // Plot defined time frame on to current time frame
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),0); 
   if(GetLastError()!=4066) Print("Historic data on Current TF is up to date (",iBars(Symbol(),0)," bars, first on ",TimeToStr(iTime(Symbol(),0,iBars(Symbol(),0)-1)),")");
   else {
       Print("Updating historic data on Current TF");
   }
   
   // 1) for(i=0,y=0;i<limit;i++)
   for(i=0,y=0;i<limit || y == 0;i++)
   {
   // 2 ) if (Time[i]<TimeArray[y]) y++;
       while(Time[i]<TimeArray[y])
   // 3) 
       y = iBarShift(NULL, TimeFrame, Time[i]);

/***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator time frame
   Rule 3:  Use 'y' for your indicator's shift value
 **********************************************************/  
 
  // ExtMapBuffer1[i]=iCCI(NULL,TimeFrame,CCIperiod,applied_price,y) ; 
   
   FastWoodieCCI[i]=iCustom(NULL,TimeFrame,"1-Retracement_Finder1m",A_period,num_bars,0,y);
   SlowWoodieCCI[i]=iCustom(NULL,TimeFrame,"1-Retracement_Finder1m",A_period,num_bars,1,y);
   HistoWoodieCCI[i]=iCustom(NULL,TimeFrame,"1-Retracement_Finder1m",A_period,num_bars,2,y);
   HistoRed[i]=iCustom(NULL,TimeFrame,"1-Retracement_Finder1m",A_period,num_bars,3,y);
   HistoBlue[i]=iCustom(NULL,TimeFrame,"1-Retracement_Finder1m",A_period,num_bars,4,y);
   
   }  
   
   if(dt==Time[0]) return(0);
   dt = Time[0];
   if(HistoWoodieCCI[1] != EMPTY_VALUE)
   {
      if(UseAlert) Alert("Retrace Found :"+Symbol() + " @: "+Period());
      if(UseEmail) SendMail("Retrace Found","A Retrace was found with Symbol "+Symbol()+" at Timeframe "+Period());
   }
//
  
   return(0);
  }
//+------------------------------------------------------------------+